/*
	SORD m5 Emulator 'Emu5'
	Skelton for retropc emulator

	Author : Takeda.Toshiya
	Date   : 2006.08.18 -

	[ keyboard ]
*/

#ifndef _KEYBOARD_H_
#define _KEYBOARD_H_

#include "../vm.h"
#include "../../emu.h"
#include "../device.h"

static const int key_map[7][8] = {
	{0x11, 0x09, 0x10, 0x10, 0x00, 0x00, 0x20, 0x0d},
	{0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38},
	{0x51, 0x57, 0x45, 0x52, 0x54, 0x59, 0x55, 0x49},
	{0x41, 0x53, 0x44, 0x46, 0x47, 0x48, 0x4a, 0x4b},
	{0x5a, 0x58, 0x43, 0x56, 0x42, 0x4e, 0x4d, 0xbc},
	{0x39, 0x30, 0xbd, 0xde, 0xbe, 0xbf, 0xe2, 0xdc},
	{0x4f, 0x50, 0xc0, 0xdb, 0x4c, 0xbb, 0xba, 0xdd}
};

class KEYBOARD : public DEVICE
{
private:
	uint8* key_stat;
	uint8* joy_stat;
public:
	KEYBOARD(VM* parent_vm, EMU* parent_emu) : DEVICE(parent_vm, parent_emu) {}
	~KEYBOARD() {}
	
	// common functions
	void initialize();
	uint32 read_io8(uint32 addr);
};

#endif
